# Get UMem List - DescribeUMem

## Overview

Get UMem List

 > 💡 (Protocol=redis: Display master-slave Redis and distributed Redis; Protocol= memcache: Display stand-alone memcache)




## Definition

### Public Parameters

| Parameter Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Action**     | string  | Corresponding API command name, the current API is `DescribeUMem`.                      | **Yes** |
| **PublicKey**  | string  | The user's public key can be obtained from [Console](https://console.genesissai.com/uaccount/api_manage)                                             | **Yes** |
| **Signature**  | string  | User signature generated based on public key and API command, see [Signature Algorithm](/docs/api/summary/signature.md)  | **Yes** |

### Request Parameters

| Parameter Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Region** | string | Region. See [List of Regions and Availability Zones](/docs/api/summary/regionlist) |**Yes**|
| **Zone** | string | Availability Zone. See [Availability Zone List](/docs/api/summary/regionlist) |No|
| **ProjectId** | string | Project ID. If not filled in, the default project is used, sub-accounts must be filled in. Please refer to the [GetProjectList interface](/docs/api/summary/get_project_list). |No|
| **Protocol** | string | Protocol Type: memcache, redis |**Yes**|
| **Offset** | int | The starting offset for pagination display, the default value is 0. |No|
| **Limit** | int | Number of items displayed per page, default value is 20 |No|
| **ResourceId** | string | Resource ID |No|

### Response Field

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **RetCode** | int | Return status code. If it is 0, it means successful return. If it is not 0, it means failure. |**Yes**|
| **Action** | string | Operation command name. |**Yes**|
| **Message** | string | Returns an error message, providing detailed description when `RetCode` is non-zero. |No|
| **TotalCount** | int | Total count based on filter conditions |No|
| **DataSet** | array[[*UMemDataSet*](#umemdataset)] | UMem Instance List, see UMemDataSet for details. |No|

#### Data Model


#### UMemDataSet

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Zone** | string | The availability zone where the instance is located, or the availability zone where the master redis is located, see [Availability Zone List](api/summary/regionlist) |No|
| **OwnSlave** | string | Does it have a read-only Slave<br />'Yes' includes<br />'No' does not include |No|
| **DataSet** | array[[*UMemSlaveDataSet*](#umemslavedataset)] | UMem Instance List UMemSlaveDataSet If there is no slave, this field does not exist |No|
| **Role** | string | Indicates whether the instance is a master or a slave, master, slave<br />Only master-slave redis returns this parameter |No|
| **RewriteTime** | int | Maintenance time for Master-Slave Redis and Distributed Redis<br />0  //0 o'clock<br />1  //1 o'clock<br />And so on<br />The standalone version of Memcache does not return this item |No|
| **VPCId** | string | UVPC |No|
| **SubnetId** | string | Subnet |No|
| **ResourceId** | string | Resource ID |No|
| **Name** | string | Resource Name |No|
| **CreateTime** | int | Creation Time |No|
| **ExpireTime** | int | Expiration Date |No|
| **Type** | string | Space Type: single (no hot backup), double (hot backup) |No|
| **Protocol** | string | Protocol Type: memcache, redis |No|
| **Size** | int | Capacity Unit GB |No|
| **UsedSize** | int | Usage Unit MB |No|
| **State** | string | ```Instance Status<br />Starting                     // Creating<br />Creating                    // Initializing<br />Deleting                    // Deleting<br />CreateFail                 // Creation Failed<br />DeleteFail                 // Deletion Failed<br />Resizing                   // Resizing<br />ResizeFail                // Resize Failed<br />Disasting                 // Disaster Recovery<br />Running                   // Running<br />SetPassword           // Setting Password<br />SetPasswordFail     // Password Setting Failed<br />ISolation                  // Shutting Down<br />Replicating              // Synchronizing<br />ReplicateDone        // Data Synchronization Completed<br />ExecTimeout           // Pending Retry<br />SlaveRecovering     // Slave Recovery<br />ReplicateFail           // Synchronization Failed<br />DelayUpgrade         // Pending Expansion Migration<br />VersionUpgrading   // Upgrading<br />VersionUpgradeFail // Upgrade Failed<br />UpgradeMemInit     // Task Initialization<br />ClusterUpgrading    // Specification Adjustment<br />SSLSwitching         // SSL Encryption Communication Switching<br />SSLSwitchFail        // SSL Encryption Communication Switching Failed<br />``` |No|
| **ChargeType** | string | Billing Mode, Yearly, Monthly, Dynamic, Trial |No|
| **Address** | array[[*UMemSpaceAddressSet*](#umemspaceaddressset)] | For IP port information, please refer to UMemSpaceAddressSet. |No|
| **Tag** | string | Business Group Name |No|
| **ResourceType** | string | distributed: Distributed version of Redis, or Distributed Memcache; single: Master-Slave version of Redis, or Single Memcache; performance: High-performance version. |No|
| **ConfigId** | string | Configuration ID of the node |No|
| **AutoBackup** | string | Do you need automatic backup, enable, disable |No|
| **BackupTime** | int | Start time for automatic backup, measured in hours, range [0-23] |No|
| **HighAvailability** | string | Enable high availability, enable, disable |No|
| **Version** | string | Redis Version Information |No|
| **SlaveZone** | string | Cross-IDC URedis, the availability zone where the slave redis is located, see [Availability Zone List](api/summary/regionlist) |No|
| **ProxyName** | string | Is URedis read-write separation enabled? |No|
| **ProductType** | int | Determine whether the backend is a outstanding resource (Not outstanding: 0 or 1 outstanding: 2 or 3) |No|
| **DefaultConfigId** | string | Is it the default configuration file,<br />true indicates default;<br />false indicates non-default. |No|
| **IsHighPerformance** | boolean | Is it a high-performance Redis,<br />true means yes;<br />false means no. |No|
| **SupportAofRollback** | boolean | Does the instance support rollback? |No|
| **AofRollbackEnable** | boolean | Is the instance rollback enabled? |No|
| **IsRWMode** | boolean |  |No|
| **SSLVersion** | string | SSL Version |No|
| **SSLEnable** | boolean | Is SSL enabled for the instance |No|
| **SSLCertExpireTime** | int | Certificate Expiration Time |No|
| **SecPolicy** | int | Security Policy. 1: Intranet Isolation, 2: Encrypted Communication, 3: Intranet Isolation + Encrypted Communication |No|
| **HasPassword** | boolean | Does the instance have a password |No|
| **UDACEnable** | boolean | Has the instance been added to the UDAC |No|

#### UMemSlaveDataSet

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Zone** | string | The availability zone where the instance is located, or the availability zone where the master redis is located, see [Availability Zone List](api/summary/regionlist) |No|
| **SubnetId** | string | Subnet |**Yes**|
| **VPCId** | string | UVPC |**Yes**|
| **VirtualIP** | string |  |**Yes**|
| **RewriteTime** | int | Master-Slave Redis returns operation and maintenance time 0//0 o'clock 1 //1 o'clock and so on |No|
| **MasterGroupId** | string | Master Instance ID |No|
| **GroupId** | string | Resource ID |No|
| **Port** | int | Port |No|
| **MemorySize** | int | Strength Size |No|
| **GroupName** | string | Resource Name |No|
| **Role** | string | Indicates whether the instance is a master or a slave, master, slave |No|
| **ModifyTime** | int | Modification Time |No|
| **Name** | string | Resource Name |No|
| **CreateTime** | int | Creation Time |No|
| **ExpireTime** | int | Expiration Date |No|
| **Size** | int | Capacity Unit GB |No|
| **UsedSize** | int | Usage Unit MB |No|
| **State** | string | Instance Status                                  Starting                  // Starting       Creating                  // Initializing     CreateFail                // Creation Failed     Fail                      // Failed     Deleting                  // Deleting       DeleteFail                // Deletion Failed     Running                   // Running         Resizing                  // Resizing   ResizeFail                // Resize Failed Configing                 // Configuring       ConfigFail                // Configuration Failed Restarting                // Restarting<br />SetPasswordFail  //Password Setting Failed |No|
| **ChargeType** | string | Billing Mode, Yearly, Monthly, Dynamic, Trial |No|
| **Tag** | string | Business Group Name |No|
| **ResourceType** | string | distributed: Distributed version of Redis, or Distributed Memcache; single: Master-Slave version of Redis, or Single Memcache; performance: High-performance version. |No|
| **ConfigId** | string | Configuration ID of the node |No|
| **Version** | string | Redis Version Information |No|
| **DefaultConfigId** | string | Is it the default configuration file;<br />true indicates default;<br />false indicates non-default. |No|
| **HasPassword** | boolean | Does the instance have a password |No|
| **UDACEnable** | boolean | Has the instance been added to the |No|

#### UMemSpaceAddressSet

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **IP** | string | UMem Instance Access IP |No|
| **PrivateDomain** | string | The UMem instance's internal network access domain address returns an empty value when it is not enabled. |No|
| **PublicIp** | string | Public IP if enabled, otherwise empty |No|
| **Port** | int | UMem Instance Access Port |No|

## Example

### Request Example
    
```
https://api.genesissai.com/?Action=DescribeUMem
&Region=CYfSjtfA
&Offset=5
&Limit=5
&ResourceId=wnfMfnQr
&Protocol=cGcleCur
&ProjectId=tWfLNsOR
&公共参数＝
&Zone=ATRtBpOx
```

### Response Example
    
```json
{
  "Action": "DescribeUMemResponse",
  "DataSet": [
    {
      "Address": [
        {
          "IP": "xdTFKPdq",
          "Port": 5
        },
        {
          "IP": "ICaNxwru",
          "Port": 1
        },
        {
          "IP": "KZqbVrIc",
          "Port": 7
        }
      ],
      "AutoBackup": "ooioDhuV",
      "BackupTime": 4,
      "ChargeType": "MtCuMDNq",
      "ConfigId": "GGDQMFVL",
      "CreateTime": 5,
      "ExpireTime": 1,
      "HighAvailability": "xYGVItde",
      "Name": "wTABuadt",
      "Protocol": "CMbNPLru",
      "ResourceId": "KNhCzsnD",
      "ResourceType": "nedYlOcN",
      "Size": 7,
      "State": "PkNmCXOe",
      "Tag": "BEgtahwU",
      "Type": "NOfFjyhX",
      "UsedSize": 4,
      "Version": "zFhXccwi"
    },
    {
      "Address": [
        {
          "IP": "ZTodkDol",
          "Port": 1
        },
        {
          "IP": "QkzdFKDl",
          "Port": 1
        },
        {
          "IP": "hwUHGGVi",
          "Port": 6
        },
        {
          "IP": "gJavQdmG",
          "Port": 2
        },
        {
          "IP": "OrwRojjw",
          "Port": 2
        },
        {
          "IP": "eJUebkxS",
          "Port": 5
        },
        {
          "IP": "uMVPWLkH",
          "Port": 6
        }
      ],
      "AutoBackup": "NfcBLyQI",
      "BackupTime": 5,
      "ChargeType": "uiZoHzyi",
      "ConfigId": "gDsoivjx",
      "CreateTime": 1,
      "ExpireTime": 8,
      "HighAvailability": "XrzqTFzK",
      "Name": "AbjCxxLb",
      "Protocol": "XzuuhHjf",
      "ResourceId": "HJjSlGLt",
      "ResourceType": "InWvDkJP",
      "Size": 9,
      "State": "VIjpXSCn",
      "Tag": "XSVehmBE",
      "Type": "ANOGVpPO",
      "UsedSize": 9,
      "Version": "ZFUDNVDq"
    },
    {
      "Address": [
        {
          "IP": "YShqePzv",
          "Port": 3
        },
        {
          "IP": "spznbmgM",
          "Port": 5
        },
        {
          "IP": "XCFVsQlL",
          "Port": 7
        },
        {
          "IP": "jCAUupec",
          "Port": 2
        },
        {
          "IP": "KorEUnXh",
          "Port": 6
        },
        {
          "IP": "LmcAuhbk",
          "Port": 7
        },
        {
          "IP": "CIvqCUOK",
          "Port": 4
        }
      ],
      "AutoBackup": "MQJPoYQr",
      "BackupTime": 5,
      "ChargeType": "CQviKnot",
      "ConfigId": "HBrVFASw",
      "CreateTime": 4,
      "ExpireTime": 5,
      "HighAvailability": "hVLLcNWN",
      "Name": "RZKzvpmh",
      "Protocol": "bAWgrRHF",
      "ResourceId": "eTwaSUzH",
      "ResourceType": "KoCPtlax",
      "Size": 3,
      "State": "wQidxUHZ",
      "Tag": "sRUNzpSY",
      "Type": "yoUDmTJX",
      "UsedSize": 4,
      "Version": "AYXbCivF"
    },
    {
      "Address": [
        {
          "IP": "cnjJWGva",
          "Port": 1
        },
        {
          "IP": "rAHqmynD",
          "Port": 1
        },
        {
          "IP": "VzuCmpAa",
          "Port": 9
        },
        {
          "IP": "IkVbzRfq",
          "Port": 4
        },
        {
          "IP": "CNPNweAR",
          "Port": 4
        },
        {
          "IP": "BsJAozyf",
          "Port": 4
        },
        {
          "IP": "vUFqoJBj",
          "Port": 7
        },
        {
          "IP": "ofvvqQZh",
          "Port": 7
        },
        {
          "IP": "FIraTIGo",
          "Port": 4
        }
      ],
      "AutoBackup": "vwdSLHVA",
      "BackupTime": 4,
      "ChargeType": "GwJzioLi",
      "ConfigId": "ULiQaVgb",
      "CreateTime": 1,
      "ExpireTime": 2,
      "HighAvailability": "nuuhdpWH",
      "Name": "QbmhcsNf",
      "Protocol": "gdeIrjKg",
      "ResourceId": "jIqIpSAp",
      "ResourceType": "fQrimsOM",
      "Size": 4,
      "State": "rxFqmOZf",
      "Tag": "kMmEoasr",
      "Type": "EVnsmeNx",
      "UsedSize": 9,
      "Version": "wEujwBHY"
    },
    {
      "Address": [
        {
          "IP": "wUfpOUYA",
          "Port": 5
        },
        {
          "IP": "BvSpBiLa",
          "Port": 3
        },
        {
          "IP": "FSUgdGnL",
          "Port": 7
        },
        {
          "IP": "GGixhLIS",
          "Port": 4
        },
        {
          "IP": "gQUiMBYV",
          "Port": 6
        },
        {
          "IP": "nejHKCBI",
          "Port": 5
        }
      ],
      "AutoBackup": "nzEkQVyH",
      "BackupTime": 6,
      "ChargeType": "qgxkWoPM",
      "ConfigId": "AIvmSCoB",
      "CreateTime": 9,
      "ExpireTime": 7,
      "HighAvailability": "qjqzRjHG",
      "Name": "ChBOhqxj",
      "Protocol": "lhgSDftR",
      "ResourceId": "bUTXOjYY",
      "ResourceType": "VylaOIJV",
      "Size": 2,
      "State": "ImYqMePS",
      "Tag": "CmCJJYAa",
      "Type": "vRdQdGTT",
      "UsedSize": 8,
      "Version": "QwICJfTd"
    },
    {
      "Address": [
        {
          "IP": "mQoEctdQ",
          "Port": 3
        },
        {
          "IP": "uZgHKYee",
          "Port": 5
        },
        {
          "IP": "leDBpMoL",
          "Port": 9
        },
        {
          "IP": "TsSuhKXT",
          "Port": 1
        },
        {
          "IP": "lOSGqWkY",
          "Port": 7
        },
        {
          "IP": "FBkomBaQ",
          "Port": 8
        },
        {
          "IP": "KtyyPoRv",
          "Port": 3
        },
        {
          "IP": "ukYmYeQa",
          "Port": 5
        }
      ],
      "AutoBackup": "anPEPEmG",
      "BackupTime": 1,
      "ChargeType": "wAffwhKn",
      "ConfigId": "ytRPrLgJ",
      "CreateTime": 5,
      "ExpireTime": 1,
      "HighAvailability": "JpeCMIqP",
      "Name": "RDFvxajX",
      "Protocol": "yJqpAmSN",
      "ResourceId": "roBVpTyn",
      "ResourceType": "HgncGXuN",
      "Size": 6,
      "State": "FyPMYAsH",
      "Tag": "NQMMBDrh",
      "Type": "saCvAuJl",
      "UsedSize": 3,
      "Version": "EkuVHZhK"
    },
    {
      "Address": [
        {
          "IP": "mvrqcHWI",
          "Port": 5
        },
        {
          "IP": "hRSPxQhf",
          "Port": 1
        },
        {
          "IP": "ffKEHpDA",
          "Port": 3
        },
        {
          "IP": "AnPwmonG",
          "Port": 9
        },
        {
          "IP": "FAuJExqC",
          "Port": 4
        },
        {
          "IP": "UzRUjIBE",
          "Port": 3
        }
      ],
      "AutoBackup": "EvPVHOmx",
      "BackupTime": 3,
      "ChargeType": "nYSzbBoP",
      "ConfigId": "vEVKUWMd",
      "CreateTime": 4,
      "ExpireTime": 1,
      "HighAvailability": "waGtiDlf",
      "Name": "VRFmczWo",
      "Protocol": "xiIwoTUv",
      "ResourceId": "PGouUYsk",
      "ResourceType": "ffIyEJqL",
      "Size": 2,
      "State": "rBeTVgaa",
      "Tag": "ZHIotklv",
      "Type": "zIiucsOC",
      "UsedSize": 7,
      "Version": "qhGDrkPo"
    },
    {
      "Address": [
        {
          "IP": "ZrVTKWBR",
          "Port": 3
        },
        {
          "IP": "EuuxPaBb",
          "Port": 6
        },
        {
          "IP": "YMEmcZQW",
          "Port": 2
        },
        {
          "IP": "NqYXHFiB",
          "Port": 7
        },
        {
          "IP": "WlRHoRYZ",
          "Port": 6
        },
        {
          "IP": "ojLcBaQA",
          "Port": 8
        },
        {
          "IP": "WahBbpNS",
          "Port": 1
        },
        {
          "IP": "qYimJEhr",
          "Port": 2
        },
        {
          "IP": "QNrwuenH",
          "Port": 9
        }
      ],
      "AutoBackup": "nnRAjmgM",
      "BackupTime": 8,
      "ChargeType": "jGeHUiMK",
      "ConfigId": "iImVJSTb",
      "CreateTime": 9,
      "ExpireTime": 6,
      "HighAvailability": "ralTPpQt",
      "Name": "SifJNKyo",
      "Protocol": "wsUXNQoi",
      "ResourceId": "XUJFsvxu",
      "ResourceType": "PdADkchN",
      "Size": 1,
      "State": "CmfSmehq",
      "Tag": "FMJrjZRv",
      "Type": "uluarTlm",
      "UsedSize": 7,
      "Version": "PSmpRZpd"
    }
  ],
  "RetCode": 0,
  "TotalCount": 5
}
```





